/*************************************************************************
  To compile and run emssamp.cpp create a project and include ems.cpp and
  emssamp.cpp in the project. Usethe __COMPACT__,__LARGE__, or __HUGE__
  data models.
  ************************************************************************/

#define TRUE 1
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <alloc.h>
#include <stdlib.h>
#include <dos.h>
#include "ems.h"

void main()
{
 int error=0;
 long  memory=260000; // 260,000

 textattr(31);
 clrscr();
 long i=0;
 unsigned char  huge*buffer =(char huge*)farmalloc(memory);

printf( 
"\n*************************************************************************"
"\n* If you find this code useful in any  of your projects, a donation of  *"
"\n* $10.00 will be greatly appreciated.                                   *"
"\n*                                                                       *"
"\n* Please make check/Money Order payable to:                             *"
"\n*                                                                       *"
"\n*		     Collie Brown                                              *"
"\n*		    545 E 82  St  Apt  3 A                                     *"
"\n*		  Brooklyn New York 11236.                                     *"
"\n*                   Tel. (718) 531-3593                                 *"
"\n*If you have any questions about the ems code you can drop me a note at *"
"\n*the above address.                                                     *"
"\n*************************************************************************");

 getch();
 clrscr();


 printf("\n************************************************************"
	"\n This program allocates 3 blocks of %ld bytes. 1 conventional "
	"\n and 2 ems.  ems block 1 is filled with  %ld of '' then copied "
	"\n to ems block 2. It is again copied from ems block 2 to conventional"
	"\n memory where it is tested for all %ld of '' "
	"\n************************************************************"
	"\n",memory,memory,memory);


 printf("\n %ld bytes of ems memory available", ems_memavail());
 printf("\n %ld bytes is the largest block of ems memory  available\n", ems_maxavail());

 if (buffer ==NULL)
    {
     printf("\n Not enough conventional memory to test program");
     exit(0);
    }
 printf("\n1  filling %ld of conventional memory  with 0",memory);
_fmemset(buffer,0,memory) ; // fill conventional memory with 0
 printf("\n2  about to allocate %ld bytes on the ems heap",memory);

 em_pointer emsbuf= em_malloc(memory);

 if (emsbuf==NULL)
     {
      printf("\n not enough ems memory to fill request ");
      exit(0);
     }

 printf("\n3  filling %ld ems memory  with '' ",memory);
 em_memset(emsbuf,254,memory);

 printf("\n4  copying %ld bytes to ems memory from conventional\n ",memory);


 printf("\n5  about to allocate  %ld more bytes on the ems heap ",memory);

 em_pointer emsbuf2=em_malloc(memory);

 if (emsbuf2==NULL)
     {
      printf(" \n not enough ems memory to fill request ");
      exit(0);
     }

 printf(" \n6  copying %ld bytes of ems from location 1 to location 2",memory);

 if ((error=em_memmove(emsbuf2,emsbuf,memory))>0)
     {
      printf(" \nerror in copying ems to ems.Error no: %x",error);
      return;
     }


 printf(" \n\n7  copying %ld bytes from ems location 2 to conventional memory",memory);


 if ((error=em_copyfrom(buffer,emsbuf,memory))>0)
   {
     printf("\n error in copy from ems to conventional memory. ERROR : %x\n",error);
     return;
   }

 printf("\n************************************************************"
	"\n Testing %ld bytes of conventional memory for '' ",memory);


 for(i=0;i<memory;i++)
     if (buffer[i]!=254)
       {
	printf("\n ERROR DETECTED AT OFFSET %ld ",i);
	sound(1000);
	delay(10);
	nosound();
	error=TRUE;
	printf("\n******press any key ********");
	getch();
	break;
       }
   if (!error)  printf("\n BUFFER TESTED OK. ");

   em_free(emsbuf);        //release ems
   em_free(emsbuf2);       //release ems
   farfree(buffer);        //release conventional mem

 printf("\n\n************************************************************");
 printf("\n %ld bytes is the largest block of ems memory available", ems_maxavail());
}
